// ------ Libraries and Definitions ------
#include "simpletools.h"
#include "abdrive360.h"
#include "wavplayer.h"
#include "fdserial.h"

// ------ Global Variables and Objects ------
fdserial *xbee;
int TurningDirections;

// ------ Function Declarations ------
void TurnLeft();
void dowav();
void Reverse();
void receiver();
void TurnRignt();
void Forward();

// ------ Main Program ------
int main()
{
  sd_mount(22, 23, 24, 25);
  xbee = fdserial_open(9,8,0,9600);
  pause(100);
  cog_run(dowav, 128);
  pause(100);
  cog_run(receiver, 128);
  drive_speed(64, 64);

}

// ------ Functions ------
void TurnLeft() {
  drive_speed(0, 0);
  pause(100);
  drive_goto((2 * 508)/65, (-2 * 508)/65);
}

void dowav() {
  wav_volume(10);
  wav_play("loveher.wav");
  pause(5000);
}

void Reverse() {
  drive_speed(0, 0);
  drive_speed(-64, -64);
}

void receiver() {
  pause(500);
  while(1) {
    dscan(xbee, "%d", &TurningDirections);
    pause(100);
    if (TurningDirections == 30) {
      TurnLeft();
      TurningDirections = 0;
    }
    else if (TurningDirections == 27) {
      TurnRignt();
      TurningDirections = 0;
    }else if (TurningDirections == 15) {
      Forward();
      TurningDirections = 0;
    }else if (TurningDirections == 29) {
      Reverse();
      TurningDirections = 0;
    }else if (TurningDirections == 23) {
      drive_speed(0, 0);
    }
  }
}

void TurnRignt() {
  drive_speed(0, 0);
  pause(100);
  drive_goto((-2 * 508)/65, (2 * 508)/65);
}

void Forward() {
  drive_speed(0, 0);
  drive_speed(64, 64);
}
